function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { IconFont } from '@zgfe/business-lib';
import { Select, Spin, Input, Form } from 'antd';
import _ from 'lodash';
import React, { useEffect, useRef, useState } from 'react';
import ZModulesCDP from '../../../../types';
import '../styles/groupConfig.less';
import { ColumnCell } from './compareTable';
import GroupSelector from './groupSelector';
import useNode from './useNode';
var classPrefix = 'flow-group-config';
var FlowGroupConfig = function FlowGroupConfig(_ref) {
  var node = _ref.node;
  var _useNode = useNode(node),
    columnList = _useNode.columnList,
    loading = _useNode.loading;
  var _useState = useState(node.getData().label),
    _useState2 = _slicedToArray(_useState, 2),
    actName = _useState2[0],
    setActName = _useState2[1];
  var _useState3 = useState([]),
    _useState4 = _slicedToArray(_useState3, 2),
    groupBy = _useState4[0],
    setGroupBy = _useState4[1];
  var _useState5 = useState([]),
    _useState6 = _slicedToArray(_useState5, 2),
    group = _useState6[0],
    setGroup = _useState6[1];
  var _useState7 = useState(false),
    _useState8 = _slicedToArray(_useState7, 2),
    inited = _useState8[0],
    setInited = _useState8[1];
  var groupRef = useRef();
  var groupByRef = useRef();
  useEffect(function () {
    setInited(false);
    var nodeData = node.getData();
    setGroupBy(nodeData.groupBy || []);
    setGroup(nodeData.group || []);
    setInited(true);
  }, []);
  useEffect(function () {
    if (!inited) return;
    node.updateData({
      group: group,
      groupBy: groupBy,
      label: actName,
      status: (group.length || groupBy.length) && actName ? 'success' : 'failed'
    });
  }, [groupBy, group, actName]);
  function onRemoveGroupBy() {
    var _groupByRef$current,
      _this = this;
    (_groupByRef$current = groupByRef.current) === null || _groupByRef$current === void 0 ? void 0 : _groupByRef$current.unselect(this);
    setGroupBy(function (list) {
      var res = _.cloneDeep(list);
      res.forEach(function (item, i) {
        if (_this.name === item.name) res.splice(i, 1);
      });
      return res;
    });
  }
  function onRemoveGroup() {
    var _groupRef$current,
      _this2 = this;
    (_groupRef$current = groupRef.current) === null || _groupRef$current === void 0 ? void 0 : _groupRef$current.unselect(this);
    setGroup(function (list) {
      var res = _.cloneDeep(list);
      res.forEach(function (item, i) {
        if (_this2.name === item.column.name) res.splice(i, 1);
      });
      return res;
    });
  }
  if (loading || !inited) {
    return /*#__PURE__*/React.createElement("div", {
      className: classPrefix
    }, /*#__PURE__*/React.createElement(Spin, {
      className: "".concat(classPrefix, "-loading")
    }));
  }
  return /*#__PURE__*/React.createElement("div", {
    className: classPrefix
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-left")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-title")
  }, /*#__PURE__*/React.createElement("span", {
    className: "title"
  }, "\u5B57\u6BB5\u5217\u8868")), columnList.map(function (column) {
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(classPrefix, "-column"),
      key: column.name
    }, /*#__PURE__*/React.createElement(ColumnCell, {
      column: column
    }));
  })), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-right")
  }, /*#__PURE__*/React.createElement(Form, null, /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u52A8\u4F5C\u540D\u79F0",
    colon: false,
    className: "action-name-box ".concat(actName === '' && 'error')
  }, /*#__PURE__*/React.createElement(Input, {
    value: actName,
    maxLength: 50,
    showCount: true,
    onChange: function onChange(e) {
      return setActName(_.trim(e.currentTarget.value));
    }
  }), actName === '' && /*#__PURE__*/React.createElement("div", {
    className: "action-name-box-error"
  }, "\u8BF7\u8F93\u5165\u52A8\u4F5C\u540D\u79F0"))), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-title")
  }, /*#__PURE__*/React.createElement("span", {
    className: "title"
  }, "\u5206\u7EC4"), /*#__PURE__*/React.createElement("span", null, "\u6700\u591A\u652F\u6301\u5206\u7EC45\u4E2A\u5B57\u6BB5")), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-list")
  }, groupBy.map(function (item) {
    return /*#__PURE__*/React.createElement("div", {
      key: item === null || item === void 0 ? void 0 : item.name,
      className: "".concat(classPrefix, "-list-item")
    }, /*#__PURE__*/React.createElement(ColumnCell, {
      column: item
    }), /*#__PURE__*/React.createElement(IconFont, {
      type: "qingchu",
      onClick: onRemoveGroupBy.bind(item)
    }));
  }), /*#__PURE__*/React.createElement(GroupSelector, {
    ref: groupByRef,
    columnList: columnList,
    disabled: columnList.length === 0 || groupBy.length >= 5,
    defaultValue: groupBy,
    onChange: function onChange(list) {
      setGroupBy(list);
    }
  })), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-title")
  }, /*#__PURE__*/React.createElement("span", {
    className: "title"
  }, "\u805A\u5408"), /*#__PURE__*/React.createElement("span", null, "\u6700\u591A\u652F\u6301\u5206\u7EC45\u4E2A\u5B57\u6BB5")), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-list")
  }, group.map(function (item, index) {
    return /*#__PURE__*/React.createElement("div", {
      key: "".concat(item.func, "-").concat(item.column.name),
      className: "".concat(classPrefix, "-list-item")
    }, /*#__PURE__*/React.createElement(Select, {
      defaultValue: item.func,
      bordered: false,
      options: [{
        label: 'max'
      }, {
        label: 'min'
      }, {
        label: 'sum',
        disabled: [ZModulesCDP.WebType.date, ZModulesCDP.WebType.string].includes(item.column.webType)
      }, {
        label: 'avg',
        disabled: [ZModulesCDP.WebType.string].includes(item.column.webType)
      }, {
        label: 'count'
      }],
      fieldNames: {
        value: 'label',
        label: 'label'
      },
      onChange: function onChange(value) {
        setGroup(function (list) {
          var res = _.cloneDeep(list);
          res[index].func = value;
          return res;
        });
      }
    }), /*#__PURE__*/React.createElement(ColumnCell, {
      column: item.column
    }), /*#__PURE__*/React.createElement(IconFont, {
      type: "qingchu",
      onClick: onRemoveGroup.bind(item.column)
    }));
  }), /*#__PURE__*/React.createElement(GroupSelector, {
    ref: groupRef,
    columnList: columnList,
    disabled: columnList.length === 0 || group.length >= 5,
    placehover: "\u6DFB\u52A0\u805A\u5408",
    defaultValue: group.map(function (item) {
      return item.column;
    }),
    onChange: function onChange(columns) {
      var map = {};
      columns.forEach(function (column) {
        map[column.name] = column;
      });
      setGroup(function (list) {
        var res = _.cloneDeep(list);
        // 先将已有字段过滤出来
        res = res.filter(function (group) {
          var match = map[group.column.name] ? true : false;
          if (match) delete map[group.column.name];
          return match;
        });
        // 添加新增字段
        for (var name in map) {
          res.push({
            func: 'max',
            column: map[name]
          });
        }
        return res;
      });
    }
  }))));
};
export default FlowGroupConfig;